













































/* krn_blocklib.c */
/****************************************************************************

		BLOCK LIBRARY FILE

*****************************************************************************
This file is used to define the block library.  It declares the       
global model table and initializes it for stars.  (Hierarchical Blocks (HBlocks)  are      
added later.)                                                        
                                                                     
Whenever the library containing the blocks is updated, this file MUST 
also be updated, and the executable re-made.  Don't forget to set    
'model_count', the total number of stars defined including NULL!     
                                                                    
*/                                                                   

#include <capsim.h>

/* Function declarations */

























extern add(),addnoise(),and(),ang(),arprocess(),
	atod(),autoxcorr(),avrow(),bdata(),
	bitmanip(),bitvec(),blindadapt(),bpf(),
	cable(),casfil(),clip(),clkdly(),
	cmplxfft(),cmux(),cmxfft(),cmxfftfile(),
	cmxifft(),convolve(),cstime(),cubepoly(),
	cxadd(),cxaddnoise(),cxconj(),cxcorr(),
	cxdelay(),cxgain(),cxmag(),cxmakecx(),
	cxmakereal(),cxmult(),cxnode(),cxphase(),
	cxplot(),cxrdfile(),cxreal(),cxreim(),
	cxsetsnr(),cxsink(),cxskip(),cxsum(),
	datagen(),dcmotor(),dco(),dco2(),
	dec_qpsk(),decbin(),decimate(),delay(),
	demux(),dff(),dffil(),divby2(),
	divider(),divider2(),ds2(),ds3(),
	ecount(),ecountfap(),encoder(),ethline(),
	expr(),eye(),fade(),fconv(),
	filtnyq(),fir(),firfil(),firtaps(),
	fm(),freq_meter(),freqimp(),fti(),
	fxadd(),fxcasfil(),fxdelay(),fxfirtaps(),
	fxgain(),fxnl(),fxnode(),gain(),
	gauss(),hilbert(),hist(),hold(),
	iirfil(),img_sar_azimuth_compress(),img_sar_create(),img_sar_range_compress(),
	imgaddnoise(),imgbreakup(),imgbuild(),imgcalc(),
	imgcolorsep(),imgcxmag(),imgcxtrl(),imgdisp(),
	imgfdct(),imgfft(),imgfilter(),imggen(),
	imghisteq(),imginterp(),imgmanip(),imgmux(),
	imgnode(),imgnonlinfil(),imgprasc(),imgprbin(),
	imgproc(),imgrdasc(),imgrdbin(),imgrdct(),
	imgrdfptiff(),imgrdtiff(),imgrtcx(),imgserin(),
	imgserout(),imgshrink(),imgsink(),imgsubimg(),
	imgwrfptiff(),imgwrtiff(),impulse(),intcntrl(),
	intdmp(),integrate(),invcust(),inventory(),
	inverse(),invert(),iqimb(),itf(),
	jitter(),jkfade(),jkff(),level(),
	limiter(),linecode(),lms(),logican(),
	lpc(),lpcanalysis(),lpf(),mau(),
	mbset(),mixer(),more(),mulaw(),
	multiplot(),multiply(),mux(),nand(),
	nl(),node(),nonlin(),nonlinsaleh(),
	nor(),null(),offset(),operate(),
	or(),patx(),phi_meter(),pid(),
	pllfilt(),plot(),plottxt(),pngen(),
	pngen2(),powmeter(),prbinimage(),predftf(),
	predlms(),prfile(),pri(),primage(),
	pulse(),pump(),pwm(),qpsk(),
	quot(),radar(),rangen(),rdaiff(),
	rdbinimg(),rdfile(),rdimage(),rdmulti(),
	repeater(),replicate(),resmpl(),roundi(),
	rxhdlc(),sampler1(),sar_azimuth_ref(),sar_chirp(),
	sar_range(),sar_range_compress(),scatter(),scattertxt(),
	scrambler(),sdet(),sdr(),secord(),
	seqgen(),server(),setsnr(),sine(),
	sink(),skip(),skipold(),slice(),
	slidefft(),sn74ls93(),spectrogram(),spectrum(),
	spectrumtxt(),spiceprb(),spread(),sqr(),
	sqrtnyq(),srff(),srlatch(),stats(),
	stc(),stcode(),str(),strch(),
	stretch(),sum(),symimp(),target(),
	tee(),tff(),threshold(),toggle(),
	transpose(),trig(),txhdlc(),unitf(),
	v29decoder(),v29encoder(),v2b(),vcm(),
	vecbit(),wave(),wraiff(),xdco(),
	xnor(),xor(),xygen(),zc(),
	zdummy(),zero(),zlpf();
/* model table Definition */
int model_count = 260;
modelEntry_t model[MAX_MODELS] = {

/* function, name, icon_id */
{ add,"add","add"},
{ addnoise,"addnoise","addnois"},
{ and,"and","and"},
{ ang,"ang","ang"},
{ arprocess,"arprocess","arproce"},
{ atod,"atod","atod"},
{ autoxcorr,"autoxcorr","autoxco"},
{ avrow,"avrow","avrow"},
{ bdata,"bdata","bdata"},
{ bitmanip,"bitmanip","bitmani"},
{ bitvec,"bitvec","bitvec"},
{ blindadapt,"blindadapt","blindad"},
{ bpf,"bpf","bpf"},
{ cable,"cable","cable"},
{ casfil,"casfil","casfil"},
{ clip,"clip","clip"},
{ clkdly,"clkdly","clkdly"},
{ cmplxfft,"cmplxfft","cmplxff"},
{ cmux,"cmux","cmux"},
{ cmxfft,"cmxfft","cmxfft"},
{ cmxfftfile,"cmxfftfile","cmxfftf"},
{ cmxifft,"cmxifft","cmxifft"},
{ convolve,"convolve","convolv"},
{ cstime,"cstime","cstime"},
{ cubepoly,"cubepoly","cubepol"},
{ cxadd,"cxadd","cxadd"},
{ cxaddnoise,"cxaddnoise","cxaddno"},
{ cxconj,"cxconj","cxconj"},
{ cxcorr,"cxcorr","cxcorr"},
{ cxdelay,"cxdelay","cxdelay"},
{ cxgain,"cxgain","cxgain"},
{ cxmag,"cxmag","cxmag"},
{ cxmakecx,"cxmakecx","cxmakec"},
{ cxmakereal,"cxmakereal","cxmaker"},
{ cxmult,"cxmult","cxmult"},
{ cxnode,"cxnode","cxnode"},
{ cxphase,"cxphase","cxphase"},
{ cxplot,"cxplot","cxplot"},
{ cxrdfile,"cxrdfile","cxrdfil"},
{ cxreal,"cxreal","cxreal"},
{ cxreim,"cxreim","cxreim"},
{ cxsetsnr,"cxsetsnr","cxsetsn"},
{ cxsink,"cxsink","cxsink"},
{ cxskip,"cxskip","cxskip"},
{ cxsum,"cxsum","cxsum"},
{ datagen,"datagen","datagen"},
{ dcmotor,"dcmotor","dcmotor"},
{ dco,"dco","dco"},
{ dco2,"dco2","dco2"},
{ dec_qpsk,"dec_qpsk","dec_qps"},
{ decbin,"decbin","decbin"},
{ decimate,"decimate","decimat"},
{ delay,"delay","delay"},
{ demux,"demux","demux"},
{ dff,"dff","dff"},
{ dffil,"dffil","dffil"},
{ divby2,"divby2","divby2"},
{ divider,"divider","divider"},
{ divider2,"divider2","divider"},
{ ds2,"ds2","ds2"},
{ ds3,"ds3","ds3"},
{ ecount,"ecount","ecount"},
{ ecountfap,"ecountfap","ecountf"},
{ encoder,"encoder","encoder"},
{ ethline,"ethline","ethline"},
{ expr,"expr","expr"},
{ eye,"eye","eye"},
{ fade,"fade","fade"},
{ fconv,"fconv","fconv"},
{ filtnyq,"filtnyq","filtnyq"},
{ fir,"fir","fir"},
{ firfil,"firfil","firfil"},
{ firtaps,"firtaps","firtaps"},
{ fm,"fm","fm"},
{ freq_meter,"freq_meter","freq_me"},
{ freqimp,"freqimp","freqimp"},
{ fti,"fti","fti"},
{ fxadd,"fxadd","fxadd"},
{ fxcasfil,"fxcasfil","fxcasfi"},
{ fxdelay,"fxdelay","fxdelay"},
{ fxfirtaps,"fxfirtaps","fxfirta"},
{ fxgain,"fxgain","fxgain"},
{ fxnl,"fxnl","fxnl"},
{ fxnode,"fxnode","fxnode"},
{ gain,"gain","gain"},
{ gauss,"gauss","gauss"},
{ hilbert,"hilbert","hilbert"},
{ hist,"hist","hist"},
{ hold,"hold","hold"},
{ iirfil,"iirfil","iirfil"},
{ img_sar_azimuth_compress,"img_sar_azimuth_compress","img_sar"},
{ img_sar_create,"img_sar_create","img_sar"},
{ img_sar_range_compress,"img_sar_range_compress","img_sar"},
{ imgaddnoise,"imgaddnoise","imgaddn"},
{ imgbreakup,"imgbreakup","imgbrea"},
{ imgbuild,"imgbuild","imgbuil"},
{ imgcalc,"imgcalc","imgcalc"},
{ imgcolorsep,"imgcolorsep","imgcolo"},
{ imgcxmag,"imgcxmag","imgcxma"},
{ imgcxtrl,"imgcxtrl","imgcxtr"},
{ imgdisp,"imgdisp","imgdisp"},
{ imgfdct,"imgfdct","imgfdct"},
{ imgfft,"imgfft","imgfft"},
{ imgfilter,"imgfilter","imgfilt"},
{ imggen,"imggen","imggen"},
{ imghisteq,"imghisteq","imghist"},
{ imginterp,"imginterp","imginte"},
{ imgmanip,"imgmanip","imgmani"},
{ imgmux,"imgmux","imgmux"},
{ imgnode,"imgnode","imgnode"},
{ imgnonlinfil,"imgnonlinfil","imgnonl"},
{ imgprasc,"imgprasc","imgpras"},
{ imgprbin,"imgprbin","imgprbi"},
{ imgproc,"imgproc","imgproc"},
{ imgrdasc,"imgrdasc","imgrdas"},
{ imgrdbin,"imgrdbin","imgrdbi"},
{ imgrdct,"imgrdct","imgrdct"},
{ imgrdfptiff,"imgrdfptiff","imgrdfp"},
{ imgrdtiff,"imgrdtiff","imgrdti"},
{ imgrtcx,"imgrtcx","imgrtcx"},
{ imgserin,"imgserin","imgseri"},
{ imgserout,"imgserout","imgsero"},
{ imgshrink,"imgshrink","imgshri"},
{ imgsink,"imgsink","imgsink"},
{ imgsubimg,"imgsubimg","imgsubi"},
{ imgwrfptiff,"imgwrfptiff","imgwrfp"},
{ imgwrtiff,"imgwrtiff","imgwrti"},
{ impulse,"impulse","impulse"},
{ intcntrl,"intcntrl","intcntr"},
{ intdmp,"intdmp","intdmp"},
{ integrate,"integrate","integra"},
{ invcust,"invcust","invcust"},
{ inventory,"inventory","invento"},
{ inverse,"inverse","inverse"},
{ invert,"invert","invert"},
{ iqimb,"iqimb","iqimb"},
{ itf,"itf","itf"},
{ jitter,"jitter","jitter"},
{ jkfade,"jkfade","jkfade"},
{ jkff,"jkff","jkff"},
{ level,"level","level"},
{ limiter,"limiter","limiter"},
{ linecode,"linecode","linecod"},
{ lms,"lms","lms"},
{ logican,"logican","logican"},
{ lpc,"lpc","lpc"},
{ lpcanalysis,"lpcanalysis","lpcanal"},
{ lpf,"lpf","lpf"},
{ mau,"mau","mau"},
{ mbset,"mbset","mbset"},
{ mixer,"mixer","mixer"},
{ more,"more","more"},
{ mulaw,"mulaw","mulaw"},
{ multiplot,"multiplot","multipl"},
{ multiply,"multiply","multipl"},
{ mux,"mux","mux"},
{ nand,"nand","nand"},
{ nl,"nl","nl"},
{ node,"node","node"},
{ nonlin,"nonlin","nonlin"},
{ nonlinsaleh,"nonlinsaleh","nonlins"},
{ nor,"nor","nor"},
{ null,"null","null"},
{ offset,"offset","offset"},
{ operate,"operate","operate"},
{ or,"or","or"},
{ patx,"patx","patx"},
{ phi_meter,"phi_meter","phi_met"},
{ pid,"pid","pid"},
{ pllfilt,"pllfilt","pllfilt"},
{ plot,"plot","plot"},
{ plottxt,"plottxt","plottxt"},
{ pngen,"pngen","pngen"},
{ pngen2,"pngen2","pngen2"},
{ powmeter,"powmeter","powmete"},
{ prbinimage,"prbinimage","prbinim"},
{ predftf,"predftf","predftf"},
{ predlms,"predlms","predlms"},
{ prfile,"prfile","prfile"},
{ pri,"pri","pri"},
{ primage,"primage","primage"},
{ pulse,"pulse","pulse"},
{ pump,"pump","pump"},
{ pwm,"pwm","pwm"},
{ qpsk,"qpsk","qpsk"},
{ quot,"quot","quot"},
{ radar,"radar","radar"},
{ rangen,"rangen","rangen"},
{ rdaiff,"rdaiff","rdaiff"},
{ rdbinimg,"rdbinimg","rdbinim"},
{ rdfile,"rdfile","rdfile"},
{ rdimage,"rdimage","rdimage"},
{ rdmulti,"rdmulti","rdmulti"},
{ repeater,"repeater","repeate"},
{ replicate,"replicate","replica"},
{ resmpl,"resmpl","resmpl"},
{ roundi,"roundi","roundi"},
{ rxhdlc,"rxhdlc","rxhdlc"},
{ sampler1,"sampler1","sampler"},
{ sar_azimuth_ref,"sar_azimuth_ref","sar_azi"},
{ sar_chirp,"sar_chirp","sar_chi"},
{ sar_range,"sar_range","sar_ran"},
{ sar_range_compress,"sar_range_compress","sar_ran"},
{ scatter,"scatter","scatter"},
{ scattertxt,"scattertxt","scatter"},
{ scrambler,"scrambler","scrambl"},
{ sdet,"sdet","sdet"},
{ sdr,"sdr","sdr"},
{ secord,"secord","secord"},
{ seqgen,"seqgen","seqgen"},
{ server,"server","server"},
{ setsnr,"setsnr","setsnr"},
{ sine,"sine","sine"},
{ sink,"sink","sink"},
{ skip,"skip","skip"},
{ skipold,"skipold","skipold"},
{ slice,"slice","slice"},
{ slidefft,"slidefft","slideff"},
{ sn74ls93,"sn74ls93","sn74ls9"},
{ spectrogram,"spectrogram","spectro"},
{ spectrum,"spectrum","spectru"},
{ spectrumtxt,"spectrumtxt","spectru"},
{ spiceprb,"spiceprb","spicepr"},
{ spread,"spread","spread"},
{ sqr,"sqr","sqr"},
{ sqrtnyq,"sqrtnyq","sqrtnyq"},
{ srff,"srff","srff"},
{ srlatch,"srlatch","srlatch"},
{ stats,"stats","stats"},
{ stc,"stc","stc"},
{ stcode,"stcode","stcode"},
{ str,"str","str"},
{ strch,"strch","strch"},
{ stretch,"stretch","stretch"},
{ sum,"sum","sum"},
{ symimp,"symimp","symimp"},
{ target,"target","target"},
{ tee,"tee","tee"},
{ tff,"tff","tff"},
{ threshold,"threshold","thresho"},
{ toggle,"toggle","toggle"},
{ transpose,"transpose","transpo"},
{ trig,"trig","trig"},
{ txhdlc,"txhdlc","txhdlc"},
{ unitf,"unitf","unitf"},
{ v29decoder,"v29decoder","v29deco"},
{ v29encoder,"v29encoder","v29enco"},
{ v2b,"v2b","v2b"},
{ vcm,"vcm","vcm"},
{ vecbit,"vecbit","vecbit"},
{ wave,"wave","wave"},
{ wraiff,"wraiff","wraiff"},
{ xdco,"xdco","xdco"},
{ xnor,"xnor","xnor"},
{ xor,"xor","xor"},
{ xygen,"xygen","xygen"},
{ zc,"zc","zc"},
{ zdummy,"zdummy","zdummy"},
{ zero,"zero","zero"},
{ zlpf,"zlpf","zlpf"}
};
