
# topology file:  pid_working.t

#--------------------------------------------------- 
# Title: -------     
# Author: -------     
# Date: -------     
# Description: -------     
#--------------------------------------------------- 

inform title PID PWM DC MOTOR Control   
inform author Sasan Ardalan, IONOTRONICS Corporation    
inform date July 2012    
inform descrip PID PWM DC MOTOR Control    

arg 0 int 2000000 "Samples"
arg 1 float 100000 "Sampling Rate"

param arg 0    num_of_samples   "Sampl"s"
param float 1    magnitude   "Enter Magnitude"
param float 32000    fs   "Enter Sampling Rate"
param float 0    freq   "Enter Frequency"
param float 0    phase   "Enter Phase"
param float 0    pace_rate   "pace rate to determine how many samples to output"
param int 128    samples_first_time   "number of samples on the first call if paced"
block sine1 sine

param arg 0    num_of_samples   "Sampl"s"
param float 200    magnitude   "Enter Magnitude"
param arg 1    fs   "Sampling Rate"
param float 0    freq   "Enter Frequency"
param float 0    phase   "Enter Phase"
param float 1    pace_rate   "pace rate to determine how many samples to output"
param int 128    samples_first_time   "number of samples on the first call if paced"
block sine0 sine

param float 1    Ra   " Armature Resistance (Ohms) "
param float 0.046    La   " Armature Inductance (Henry) "
param float 0.093    J   " Total Moment Inertia (kg-m**2) "
param float 0.007    Bv   " Viscous Friction Constatnt (Nt-m/rd/sec) "
param float 0.55    KaPhi   " Back Electromotive Force and Torque Constant (Volt/rd or Nt-m/Amper) "
param float 1e-05    T   " Sampling Time Period (sec) "
block dcmotor1 dcmotor

param file w.dat    file_name   "Name of output file"
param int 1    control   "Print output control (0/Off, 1/On)"
param int 0    bufferType   "Buffer type:0= Float,1= Complex, 2=Integer"
block prfile0 prfile

param int 128    npts   "Number of points in each plot (dynamic window size)"
param int 0    skip   "Points to skip before first plot"
param file W    title   "Plot title"
param file Samples    x_axis   "X Axis label"
param file Y    y_axis   "Y-Axis label"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    mode   "0=Static,1=Dynamic"
param int 10000    samplingRate   "Sampling Rate"
block prbplot0968 plottxt

param file ia.dat    file_name   "Name of output file"
param int 1    control   "Print output control (0/Off, 1/On)"
param int 0    bufferType   "Buffer type:0= Float,1= Complex, 2=Integer"
block prfile1 prfile

param int 128    npts   "Number of points in each plot (dynamic window size)"
param int 0    skip   "Points to skip before first plot"
param file IA    title   "Plot title"
param file Samples    x_axis   "X Axis label"
param file Y    y_axis   "Y-Axis label"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    mode   "0=Static,1=Dynamic"
param int 10000    samplingRate   "Sampling Rate"
block prbplot066 plottxt

param float -0.001    factor   "Gain factor"
block gain0 gain

param float 1    factor   "leakage factor  <= 1.0"
block integrate0 integrate

param int 128    npts   "Number of points in each plot (dynamic window size)"
param int 0    skip   "Points to skip before first plot"
param file actual    title   "Plot title"
param file Samples    x_axis   "X Axis label"
param file Y    y_axis   "Y-Axis label"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    mode   "0=Static,1=Dynamic"
param int 1    samplingRate   "Sampling Rate"
block plot1 plottxt

param int 1    samples_delay   "Enter number of samples to delay"
block delay1 delay

param float 10000    Kp   " Kp "
param float 10000    Ki   " Ki "
param float 10000    Kd   " Kd "
param float 1e+06    maxOut   " Maximum for PWM"
param float -1e+06    minOut   " Minimum for PWM"
param int 0    pwmBypass   " PWM Bypass"
param float 1e-05    timeInterval   " Time Interval "
block pid0 pid

param int 128    npts   "Number of points in each plot (dynamic window size)"
param int 0    skip   "Points to skip before first plot"
param file pid    title   "Plot title"
param file Samples    x_axis   "X Axis label"
param file Y    y_axis   "Y-Axis label"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    mode   "0=Static,1=Dynamic"
param int 1    samplingRate   "Sampling Rate"
block plot2 plottxt

param float 10    magnitude   "Magnitude"
param float 10000    freq   "Frequency (Hz)"
param arg 1    fs   "Sampling Rate"
param float 0    dcOffset   "DC offset"
block pwm0 pwm

param int 1000    samples_delay   "Enter number of samples to delay"
block delay0 delay

param int 128    npts   "Number of points in each plot (dynamic window size)"
param int 0    skip   "Points to skip before first plot"
param file PWM    title   "Plot title"
param file Samples    x_axis   "X Axis label"
param file Y    y_axis   "Y-Axis label"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    mode   "0=Static,1=Dynamic"
param int 1    samplingRate   "Sampling Rate"
block plot0 plottxt

connect sine1 0 dcmotor1 1  	{sine1:NULL:NULL,dcmotor1: TL : float }
connect sine0 0 pid0 0  	{sine0:NULL:NULL,pid0: x : float }
connect dcmotor1 0 prfile0 0  	
connect dcmotor1 1 prfile1 0  	
connect prfile0 0 prbplot0968 0  	
connect prbplot0968 0 gain0 0  	{prbplot0968:NULL:NULL,gain0:x:float}
connect prfile1 0 prbplot066 0  	
connect gain0 0 integrate0 0  	{gain0:NULL:NULL,integrate0:in:float}
connect integrate0 0 plot1 0  	
connect plot1 0 delay1 0  	{plot1:NULL:NULL,delay1:x:float}
connect delay1 0 pid0 1  	{delay1:NULL:NULL,pid0: desired : float }
connect pid0 0 plot2 0  	
connect plot2 0 pwm0 0  	{plot2:NULL:NULL,pwm0: pulseWidth : float }
connect pwm0 0 delay0 0  	{pwm0:NULL:NULL,delay0:x:float}
connect delay0 0 plot0 0  	
connect plot0 0 dcmotor1 0  	{plot0:NULL:NULL,dcmotor1: Va : float }

